=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for socket by Lenart Janos.
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

configure: configure-stamp
configure-stamp:
	dh_testdir
	touch configure-stamp

build: configure-stamp build-arch build-indep
build-arch:
	dh_testdir
	dh_auto_build
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-arch configure-stamp
	$(MAKE) clean
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs usr/bin
	$(MAKE) install DESTDIR=$(CURDIR)/debian/socket

# Build architecture-independent files here.
build-indep:
binary-indep: build-indep install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build-arch install
	dh_testdir
	dh_testroot
	dh_installdocs README
	dh_installman socket.1
	dh_installchangelogs CHANGES
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build-indep build clean binary-indep binary-arch binary install configure
