## socket demo

=== Makefile ===
#*******************************************************************************
# include ZTE application makefile
#*******************************************************************************
include $(zte_app_mak)

##############USER COMIZE BEGIN################

EXEC = socket_demo
OBJS = $(patsubst %.c,%.o,$(wildcard *.c))

CFLAGS += -I.
CFLAGS += -I$(zte_app_path)/include


CFLAGS += -g
CFLAGS += -g -Werror=implicit-function-declaration

LDLIBS += -lpthread

#*******************************************************************************
# targets
#*******************************************************************************
all: $(EXEC)

$(EXEC): $(OBJS)
	$(CC) $(LDFLAGS) -o $@ $^ -Wl,--start-group $(LDLIBS) -Wl,--end-group
	@cp $@ $@.elf

romfs:
	$(ROMFSINST) $(EXEC) /sbin/$(EXEC)

clean:
	-rm -f $(EXEC) *.elf *.gdb *.o
