## socket vmnet-1.2.1

=== Makefile ===
--- 
+++ 
@@ -1,16 +1,23 @@
 # PREFIX should be only writable by the root to avoid privilege escalation with launchd or sudo
 PREFIX ?= /opt/socket_vmnet
 
+# DEBUG=1 is known to break reproducible builds
+DEBUG ?=
+
 export SOURCE_DATE_EPOCH ?= $(shell git log -1 --pretty=%ct)
-# https://reproducible-builds.org/docs/archives/
-TAR ?= gtar --sort=name --mtime="@$(SOURCE_DATE_EPOCH)" --owner=0 --group=0 --numeric-owner --pax-option=exthdr.name=%d/PaxHeaders/%f,delete=atime,delete=ctime
-TOUCH ?= gtouch -d @$(SOURCE_DATE_EPOCH)
+SOURCE_DATE_EPOCH_ISO8601 := $(shell date -u -Iseconds -r $(SOURCE_DATE_EPOCH) | sed -e s/+00:00/Z/)
+
+TAR ?= tar --uid=0 --gid=0 --numeric-owner
+TOUCH ?= touch -d $(SOURCE_DATE_EPOCH_ISO8601)
 # Not necessary to use GNU's gzip
 GZIP ?= gzip -9 -n
 DIFFOSCOPE ?= diffoscope
 STRIP ?= strip
 
-CFLAGS ?= -O3
+CFLAGS ?= -O3 -Wall -Wextra -pedantic
+ifeq ($(DEBUG),1)
+	CFLAGS += -g
+endif
 
 VERSION ?= $(shell git describe --match 'v[0-9]*' --dirty='.m' --always --tags)
 VERSION_TRIMMED := $(VERSION:v%=%)
@@ -46,6 +53,7 @@
 	$(CC) $(CFLAGS) -o $@ $(LDFLAGS) $^
 
 install.bin: socket_vmnet socket_vmnet_client
+	logger "Installing executables for socket_vmnet $(VERSION) in $(DESTDIR)/$(PREFIX)/bin"
 	mkdir -p "$(DESTDIR)/$(PREFIX)/bin"
 	cp -a socket_vmnet "$(DESTDIR)/$(PREFIX)/bin/socket_vmnet"
 	cp -a socket_vmnet_client "$(DESTDIR)/$(PREFIX)/bin/socket_vmnet_client"
@@ -53,6 +61,7 @@
 	$(STRIP) "$(DESTDIR)/$(PREFIX)/bin/socket_vmnet_client"
 
 install.doc: README.md LICENSE launchd etc_sudoers.d
+	logger "Installing documentation for socket_vmnet $(VERSION) in $(DESTDIR)/$(PREFIX)/share/doc"
 	mkdir -p "$(DESTDIR)/$(PREFIX)/share/doc/socket_vmnet"
 	cp -a $? "$(DESTDIR)/$(PREFIX)/share/doc/socket_vmnet"
 
@@ -65,6 +74,7 @@
 
 define load_launchd
 	# Hint: try `launchctl enable system/$(1)` if the `launchctl bootstrap` command below fails
+	logger "Installing launchd service for socket_vmnet $(VERSION) in $(DESTDIR)/Library/LaunchDaemons/$(1).plist"
 	launchctl bootstrap system "$(DESTDIR)/Library/LaunchDaemons/$(1).plist"
 	launchctl enable system/$(1)
 	launchctl kickstart -kp system/$(1)
@@ -80,6 +90,7 @@
 
 .PHONY: uninstall.bin
 uninstall.bin:
+	logger "Uninstalling executables for socket_vmnet"
 	rm -f "$(DESTDIR)/$(PREFIX)/bin/socket_vmnet"
 	rm -f "$(DESTDIR)/$(PREFIX)/bin/socket_vmnet_client"
 
@@ -88,6 +99,7 @@
 	rm -rf "$(DESTDIR)/$(PREFIX)/share/doc/socket_vmnet"
 
 define unload_launchd
+	logger "Uninstalling launchd service for socket_vmnet"
 	launchctl bootout system "$(DESTDIR)/Library/LaunchDaemons/$(1).plist" || true
 endef
 
@@ -119,7 +131,10 @@
 	rm -rf _artifacts/$(1)
 	$(MAKE) ARCH=$(1) DESTDIR=_artifacts/$(1) install.bin install.doc
 	file -bp _artifacts/$(1)/$(PREFIX)/bin/socket_vmnet | grep -q "Mach-O 64-bit executable $(1)"
-	$(TAR) -C _artifacts/$(1) -cf _artifacts/socket_vmnet-$(VERSION_TRIMMED)-$(1).tar ./
+	# BSD tar does not have `--mtime=TIMESTAMP` option
+	find _artifacts/$(1) -exec $(TOUCH) {} \;
+	# BSD tar does not have `--sort=name` option
+	(cd _artifacts/$(1) && find -s . -print0 | $(TAR) -cf ../socket_vmnet-$(VERSION_TRIMMED)-$(1).tar --null -n --files-from /dev/stdin)
 	$(GZIP) _artifacts/socket_vmnet-$(VERSION_TRIMMED)-$(1).tar
 	rm -rf _artifacts/$(1)
 	$(MAKE) clean
